## telegram-desktop 2.1.6+ds

=== debian/changelog ===
telegram-desktop (2.1.6+ds-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Disable Reduce-boldface.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 15 May 2020 20:15:42 -0700
