## telegram-desktop 2.1.7+ds

=== Telegram/CMakeLists.txt ===
--- 
+++ 
@@ -90,6 +90,7 @@
         PRIVATE
             desktop-app::external_statusnotifieritem
             desktop-app::external_dbusmenu_qt
+            desktop-app::external_fcitx_qt5
             desktop-app::external_fcitx5_qt5
             desktop-app::external_hime_qt
         )
@@ -403,5 +404,3 @@
     data/data_shared_media.h
     data/data_sparse_ids.cpp
     data/data_sparse_ids.h
-    data/data_streaming.cpp
-    data/data_streaming.h
