=== debian/changelog ===
telegram-desktop (2.1.7+ds-2~ubuntu20.04.1) focal; urgency=medium

  * Backport from groovy to focal (LP: #1880307).
  * Revert "Switch to Hunspell spellchecker from Enchant".
    - Preserves current behaviour and leaves untouched user settings in
      existing installations.
  * New Backport-to-legacy-GSL.patch.
    - Needed for build against Microsoft Guidelines Support Library of version
      less than 3.0.0.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 30 May 2020 21:21:51 +0300

telegram-desktop (2.1.7+ds-2) unstable; urgency=medium

  * Rewrite Set-semibold-font.patch to fix lacking boldface
    in message input box under KDE.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 30 May 2020 19:28:39 +0300

telegram-desktop (2.1.7+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add Set-semibold-font.patch (Closes: #961526)
    - The patch partially fixes bold font in KDE. Although, boldface is still
      unused in the input box.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 26 May 2020 20:00:13 +0300
