=== debian/control ===
--- 
+++ 
@@ -1,28 +1,28 @@
 Source: telegram-desktop
 Section: net
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (=12)
+Build-Depends: debhelper (>=12.8~), debhelper-compat (=12)
 Build-Depends-Arch:
  cmake (>=3.16.0),
  libavcodec-dev (>=7:3.2),
  libavformat-dev (>=7:3.2),
  libavutil-dev (>=7:3.2),
  libdbusmenu-qt5-dev,
+ libenchant-dev | libenchant-2-dev,
  libexpected-dev,
  libgtk2.0-dev,
- libhunspell-dev,
  liblz4-dev,
  liblzma-dev,
  libmapbox-variant-dev,
  libminizip-dev (>=1.1),
- libmsgsl-dev (>=3.0.0),
+ libmsgsl-dev (>=1.0.0), libmsgsl-dev (<<2.0.0) | libmsgsl-dev (>=2.1.0), libmsgsl-dev (<<3.0.0),
  libopenal-dev,
  libopus-dev (>=1.1),
  libqrcodegencpp-dev,
  librange-v3-dev (>=0.10.0),
- librlottie-dev (>= 0~git20200305.a717479~),
+ librlottie-dev,
  libssl-dev (>=1.0.1),
  libswresample-dev (>=7:3.2),
  libswscale-dev (>=7:3.2),
